#!/usr/bin/perl
use DBI;
&ReadParse;

print "Content-Type: text/html\n\n";

$dbuser = 'db'.$in{'Username'};
$dbpass = $in{'Passwort'};
$pfad = $ENV{'DOC_ROOT'};

if (!$in{'Username'} || !$in{'Passwort'})
{
  mainmenu();
}

if ($in{'aktion'} eq "create")
{
 create_db();
}

if ($in{'aktion'} eq "abfrage")
{
 abfrage();
}
elsif ($in{'aktion'} eq "adddir")
{
  modify();
}
elsif ($in{'aktion'} eq "deldir")
{
  modify();
}
elsif ($in{'aktion'} eq "delmenu")
{
  delmenu();
}
elsif ($in{'aktion'} eq "addmenu")
{
  addmenu();
}



sub abfrage
{
  $now = time();
  $time = time();
  $time = $time - 900;

  my ($dbh) = doconnect($dbuser,$dbpass,$dbuser);

  $qry = "SELECT dir FROM quota_check where timestamp <= $time";
  $sth = $dbh->prepare($qry);
  $sth->execute();
  while ($dir = $sth->fetchrow_array)
  {
    if (-d "$pfad/$dir")
    {
	  $du = `/usr/bin/du -s -H $pfad/$dir 2>&1`;
	  $du =~ /^(\d?\.*\d*)\s?([a-z]+)/i;
	  if ($2 eq "kB")
	  {
	    $einheit = "Kbytes";
	  }
	  elsif ($2 eq "MB")
	  {
	    $einheit = "Mbytes";
	  }
	  $qry2 = "UPDATE quota_check SET size = '$1 $einheit', timestamp = '$now' WHERE dir = '$dir'";
	  $sth2 = $dbh->prepare($qry2);
	  $sth2->execute();
    }
    else
    {
      print "Das Verzeichniss $pfad/$dir existiert leider nicht und wurde aus der DB gelscht<br>\n";
	  $qry3 = "DELETE FROM quota_check WHERE dir = '$dir'";
	  $sth3 = $dbh->prepare($qry3);
	  $sth3->execute();
    }
  }

  $qry = "SELECT dir,size FROM quota_check";
  $sth = $dbh->prepare($qry);
  $sth->execute();
  while (($dir,$size) = $sth->fetchrow_array)
  {
    print "Verzeichnis $dir belegt $size Speicherplatz (inkl. aller Unterverzeichnisse) <br>";
  }
  $dbh->disconnect();
  print "<br><a href=\"quota.pl\">Zurck</a>";
}

sub delmenu
{

  my ($dbh) = doconnect($dbuser,$dbpass,$dbuser);
  my ($qry) = "SELECT dir FROM quota_check";
  my ($sth) = $dbh->prepare($qry);
  $sth->execute();
  if ($sth->rows eq 0)
  {
    print "Keine Verzeichnise vorhanden<br>\n";
    mainmenu();
  }
  while ($dir = $sth->fetchrow_array)
  {
    $option .= "<option value=\"$dir\">$dir</option>\n";
  }
  print <<"ENDE";
  <form action="quota.pl" method="POST">
  <input type="hidden" name="Username" value="$in{'Username'}">
  <input type="hidden" name="Passwort" value="$in{'Passwort'}">
  <input type="hidden" name="aktion" value="deldir">
  <select size="1" name="dir">
  $option
  </select>
  <input type="submit" value="Entfernen">
  </form>
ENDE

  exit;
}

sub addmenu
{

  print <<"ENDE";
  <form action="quota.pl" method="POST">
  <input type="hidden" name="Username" value="$in{'Username'}">
  <input type="hidden" name="Passwort" value="$in{'Passwort'}">
  <input type="hidden" name="aktion" value="adddir">
Verzeichniss hinzufgen:  <input type="text" name="dir" size="30">(z.B. "webseiten")<br>
  <input type="submit" value="Hinzufgen">
  </form>
ENDE

  exit;
}


sub doconnect
{
  ($dbuser,$dbpass,$database) = @_;
  my $mysql_host='localhost';
  my $driver="mysql";
  my $dsn="DBI:$driver:$database:$mysql_host";
  return DBI->connect($dsn,$dbuser,$dbpass) || print "Verbindung zur Datenbank konnte nicht hergestellt werden";die;
}

sub modify
{

  $dir = $in{'dir'};
  my ($dbh) = doconnect($dbuser,$dbpass,$dbuser);
  if ($dir ne "" && $in{'aktion'} eq "adddir")
  {
    my ($qry) = "INSERT INTO quota_check (dir) VALUES('$dir')";
    my ($sth) = $dbh->prepare($qry);
    $sth->execute();

  }
  if ($dir ne "" && $in{'aktion'} eq "deldir")
  {
    my $qry = "DELETE FROM quota_check WHERE dir = '$dir'";
    my $sth = $dbh->prepare($qry);
    $sth->execute();
  }
  $dbh->disconnect();
  abfrage();
}

sub create_db
{
  my ($dbh) = doconnect($dbuser,$dbpass,$dbuser);
  my ($qry) = "CREATE TABLE quota_check (
	       ID int NOT NULL AUTO_INCREMENT PRIMARY KEY,
               dir varchar(255) NOT NULL,
	       size varchar(20),
	       timestamp int DEFAULT 1,
	       unique(dir))";
  my ($sth) = $dbh->prepare($qry);
  $sth->execute();
  print "Datenbank erfolgreich angelegt<br>\n";
  mainmenu();
}

sub mainmenu
{
  print <<"EOF";
<html>
<head>
<title>Quotatool</title>
</head>
<body>
<form method="POST" action="quota.pl">
  <p>Auftragsnummer:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
  <input type="text" name="Username" size="20"><br>
  SQL-Passwort:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
  <input type="password" name="Passwort" size="20"></p>
  <p>&nbsp;</p>
    <select size="1" name="aktion">
  <option selected value="create">Datenbank anlegen</option>
  <option value="abfrage">Speicherplatz abfragen</option>
  <option value="addmenu">Verzeichnis hinzufgen</option>
  <option value="delmenu">Verzeichnis entfernen</option>
  </select>
  <p><input type="submit" value="Abschicken" name="B1"></p>
</form>
</body>
</html>
EOF
  exit;
}

sub ReadParse
{
    local (*in) = @_ if @_;


  local ($i, $loc, $key, $val);

  # Read in text
  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in = $ENV{'QUERY_STRING'};
  } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/&/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;

  }

  return 1; # just for fun
}
